#include <stdbool.h>
#include <stdint.h> 
#include <avr/pgmspace.h>
#include "main.h"
#include <util/delay.h>
#include "i2clcd.h"
#include "i2cmaster.h"
#include "ir.h"
#include <avr/interrupt.h>
//===========================================================
//#define BAUD 9600
#define BAUD 19200
//#define BAUD 38400
//===========================================================
#define MYUBRR F_CPU/16L/BAUD-1  //Formel....
#define RX_BUFFER_SIZE 128
char rxBuffer[RX_BUFFER_SIZE];
u8 tx_str[5]={'$','x','x','x','$'};

v uint8_t rxReadPos = 0;
v uint8_t rxWritePos = 0;
v u8 comand_zl,twx_comand;

v u32 ct_wr_in_rx;
v u32 ct_rd_from_rx;
v u8 crc;
v u8 rx_len;
v u8 zl_alt=1;


int init_usart(void)
{
// DDRB = (1<<PB0);  // XCK0 ATMega644
 //DDRD |= (1<<PD4);  // XCK0 ATMega328
 DDRD &=~(1<<PD0);//rx-miso
 DDRD |= (1<<PD1);//tx-mosi

	UBRR0H = (MYUBRR >> 8);
	UBRR0L =  MYUBRR;

	UCSR0B = (1 << TXEN0)  | (1 << TXCIE0) | (1 << RXEN0)  | (1 << RXCIE0);
	UCSR0C = (1 << UCSZ01) | (1 << UCSZ00);
	sei();
 }
//===========================================================
/*    Protokoll:

Header: src      M092P005
		dst
		len100
		len10
		len1
		cmd100
		cmd10
		cmd1
		
payload

		crc100
		crc10
		crc1
		Lf - terminate
 
 
*/
//===========================================================

void twx_rx_auswerten(void){
u8 i=0;

		rx_len= (rxBuffer[1]-48)*100;
		rx_len= rx_len+(rxBuffer[2]-48)*10;
		rx_len= rx_len+(rxBuffer[3]-48);
		
		twx_comand= (rxBuffer[5]-48)*100;
		twx_comand= twx_comand+(rxBuffer[6]-48)*10;
		twx_comand= twx_comand+(rxBuffer[7]-48);
	//			  lcd_goto(4,1);lcd_int(twx_comand);lcd_write("/");lcd_int(rx_len);
		
			switch (twx_comand)
			  {
				  
			    case 1 ... 4:
				//  posLcd=0;
				if(rxBuffer[8]=='*'){
					lcd_goto(zl_alt,1);lcd_write(" ");
				}
				  lcd_goto(twx_comand,1);
				  for (i=0+8;i<(rx_len-4);i++)lcd_char(rxBuffer[i]);
				  zl_alt=twx_comand;
				  //lcd_goto(4,1);lcd_int(twx_comand);lcd_write("/");lcd_int(rx_len);
			      break;
				  
			    case 5:
				  lcd_clear(0);
				  _delay_ms(50);
				  for (i=0+8;i<(rx_len-4);i++)lcd_char(rxBuffer[i]);
			      break;
			
			    case (6):
			      lcd_goto(2,1);
				  lcd_write("hello world         ");
			      break;
			
			  }
//				  lcd_goto(4,1);lcd_int(twx_comand);lcd_write("/");lcd_int(rx_len);
				  
//for (i=0;i<(8);i++)lcd_char(rxBuffer[i]);
}

//===========================================================

ISR(USART_RX_vect)
{
u8 i=0;
		led1_tog;
		rxBuffer[rxWritePos] = UDR0;
//		lcd_char(rxBuffer[rxWritePos]);
		
		if(rxBuffer[rxWritePos]!=10){
			rxWritePos++;
		}else{
		
		//bertragung beendet
		rxWritePos=0;
		twx_rx_auswerten();
		}
}
//===========================================================

ISR(USART_TX_vect)
{;
}
//===========================================================

void send_txstr(u8 *str,u8 anz){
u8 ct=0;
	while(ct<anz){
		while(!(UCSR0A & (1<<UDRE0)));
		UDR0 =str[ct++];

	}
		
}
//===========================================================





//===========================================================

int main(void)
{
u16	res_ir;
u8 ir_cmd;
u8 ir_adr;

	led1_init;
	i2c_init();
	lcd_init();
	lcd_write("test");
	init_usart();



//=========================================================	
    while (1) {

//================= polling ======================
		if(ir_pin){
				res_ir= ir_signal();
				
				lcd_goto(3,12);
				lcd_int(res_ir>>8);lcd_write("/");
				lcd_int(res_ir&0xff);lcd_write("/");
// 				lcd_goto(2,1);lcd_int(ir_div);
				_delay_ms(300);
//				lcd_goto(3,2);lcd_write("#");
 
		  if(res_ir>>8==254){
				ir_cmd=res_ir&0xff;
				
				tx_str[1]=ir_cmd/100+48;
				tx_str[2]=(ir_cmd%100)/10+48;
				tx_str[3]=(ir_cmd%10)+48;/**/
				send_txstr(tx_str,5);
				res_ir=0;
		/*  */	}
		   }//ir_pin	
//================= polling ======================
	
	
    
    }//while
}
