#define F_CPU 8000000       // CPU clock in Hz

#define GLUE(a, b)  a##b
#define sbi(var, bit) (var|=1<<bit)//set
#define cbi(var, bit) (var&=~(1<<bit))//clear
#define tbi(var, bit) (var^=1<<bit)//toggle
#define gbi(var, bit) (var>>bit&1)//get
#define wait  _delay_ms(1000)
#define wait10  do{_delay_ms(3333);_delay_ms(3333);_delay_ms(3333);}while(0)
//2^8 = 256
//2^16 = 65.536
//2^32 = 4.294.967.296
//2^64 = 18.446.744.073.709.551.616
#define u8  uint8_t //255
#define u16 uint16_t//65.535
#define u32 uint32_t// 4.294.967.295
#define i8  int8_t //+-127
#define i16 int16_t
#define i32 int32_t
#define v volatile
#define _BV(x) (1<<x)
#define GLUE(a, b)      a##b

#define false 0
#define true 1

//avr specific
#if zucAVR
#define PORT(x)         GLUE(PORT, x)
#define PIN(x)          GLUE(PIN, x)
#define DDR(x)          GLUE(DDR, x)
#define pinSET(x,y)     PORT(x) |=(1<<y)
#define pinCLR(x,y)     PORT(x)&=~(1<<y)
#define pinTOG(x,y)     PORT(x)^=(1<<y)
#define pinDIRin(x,y)     DDR(x)&=~(1<<y)
#define pinDIRout(x,y)     DDR(x)|=(1<<y)
#define pinVAL(x,y)     (PIN(x)&(1<<y))
#define pinPULLUP(x,y,z)   (z)?(PORT(x)|=(1<<y)):(PORT(x)&=~(1<<y))//0_no 
#define u8x          uint8_t

#define ti_prescaler_clr   ((1 << CS02)|(1 << CS01)|(1 << CS00))
#define ti_prescaler_1     (1 << CS00)
#define ti_prescaler_8     (1 << CS01)
#define ti_prescaler_64_32    (1 << CS01)|(1 << CS00)
#define ti_prescaler_256_64   (1 << CS02)
#define ti_prescaler_1024_128  (1 << CS02)|(1 << CS00)
#endif


#define led2_tog (PORT(led2_port) ^=1<<led2_pin)
#define led2_on   PORT(led2_port)|=1<<led2_pin
#define led2_off   PORT(led2_port)&=~(1<<led2_pin)
#define led2_blink {led2_tog;_delay_ms(300);led2_tog;_delay_ms(300);led2_tog;\
		_delay_ms(300);led2_tog;_delay_ms(300);}
#define led2_init sbi(DDR(led2_port),led2_pin);led2_blink;

#define led1_tog (PORT(led1_port) ^=1<<led1_pin)
#define led1_on   PORT(led1_port)|=1<<led1_pin
#define led1_off   PORT(led1_port)&=~(1<<led1_pin)
#define led1_blink {led1_tog;_delay_ms(300);led1_tog;_delay_ms(300);led1_tog;\
		_delay_ms(300);led1_tog;_delay_ms(300);}
#define led1_init sbi(DDR(led1_port),led1_pin);led1_blink;

void nothing(void);

//led
#define led1_port 			B
#define led1_pin 			5



